import type { CurrentBlock, ElectrumBalances, ElectrumTransaction, ElectrumUTXO, ElectrumTransactionShort } from '../types';
declare const defaultConfig: {
    host: string;
    port: number;
    protocol: string;
};
export declare type BtcvApiConfig = typeof defaultConfig;
export declare class BtcvApiClient {
    private client;
    constructor(config?: BtcvApiConfig);
    connect(): Promise<void>;
    close(): any;
    getScriptHash(address: string): string;
    getBalances(address: string): Promise<ElectrumBalances>;
    getCurrentBlock(): Promise<CurrentBlock>;
    getTransactions(address: string): Promise<ElectrumTransactionShort[]>;
    getTransaction(hash: string, verbose: boolean): Promise<ElectrumTransaction>;
    getUnspentList(address: string): Promise<ElectrumUTXO[]>;
    broadcastTransaction(rawtx: any): any;
    blockchainEstimateFee(number: number): any;
    getMempool(address: string): any;
}
export {};
