"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BtcvApiClient = void 0;
const client_1 = require("./client");
// import ElectrumClient from '@codewarriorr/electrum-client-js';
const bitcoin = __importStar(require("bitcoinjs-lib"));
const util_1 = require("./util");
const VaultNetwork = {
    messagePrefix: '\x18Bitcoin Vault Signed Message:\\n',
    bech32: 'royale',
    bip32: {
        public: 0x0488b21e,
        private: 0x04358394, // ?????
    },
    pubKeyHash: 0x4e,
    scriptHash: 0x3c,
    wif: 0xef, // ?????
};
// TODO: SSL
const defaultConfig = {
    host: '127.0.0.1',
    port: 50002,
    protocol: 'ssl',
};
class BtcvApiClient {
    // TODO: constructor config
    constructor(config = defaultConfig) {
        // this.client = new ElectrumClient(config.host, config.port, config.protocol);
        // TODO: refine options
        // this.client = new ElectrumClient(config.host, config.port, config.protocol, { isServer: false });
        this.client = new client_1.ElectrumClient(config.host, config.port, config.protocol, {});
    }
    connect() {
        // // this.client = new ElectrumClient(...config);
        // // this.client = new ElectrumClient(config.host, config.port, config.protocol);
        // await this.client.connect(
        //   'electrum-client-js', // optional client name
        //   '1.4.2' //
        // );
        // // await this.client.keepAlive();
        //
        // return this; // TODO: remove ?
        return this.client.connect('btcv-api-client-js', // optional client name
        '2.0' //
        // '1.4.2' //
        // '6.6.6' //
        );
    }
    close() {
        return this.client.close();
    }
    // async getScriptHash(address: string): Promise<string> {
    getScriptHash(address) {
        try {
            let script = bitcoin.address.toOutputScript(address, VaultNetwork);
            let hash = bitcoin.crypto.sha256(script);
            // let reversedHash = Buffer.from(bufferReverse(hash)); // TODO: do we need buffer.from here ?!
            // let reversedHash = ; // TODO: do we need buffer.from here ?!
            return util_1.bufferReverse(hash).toString('hex');
        }
        catch (e) {
            // `${invalidAddress} has no matching Script`,
            throw new Error('Invalid address');
        }
    }
    getBalances(address) {
        return __awaiter(this, void 0, void 0, function* () {
            // let balances: ElectrumBalances = {
            //   confirmed: 0,
            //   unconfirmed: 0,
            //   alert_incoming: 0;
            //   alert_outgoing: 0;
            // };
            //
            // // try {
            // const scriptHash = this.getScriptHash(address);
            // // return await this.client.blockchain_scripthash_getBalance(script);
            // balances = await this.client.blockchain_scripthash_getBalance(scriptHash);
            // // balances = await this.client.blockchain_scripthash_getBalance(script);
            // // } catch (e) {
            // //   console.log("GET_BALANCE", e);
            // // }
            // //
            // return balances;
            const scriptHash = this.getScriptHash(address);
            return this.client.blockchain_scripthash_getBalance(scriptHash);
        });
    }
    getCurrentBlock() {
        // TODO: is connected ? (validate)
        return this.client.blockchain_headers_subscribe();
    }
    getTransactions(address) {
        // TODO: is connected ? (validate)
        const scriptHash = this.getScriptHash(address);
        return this.client.blockchain_scripthash_getHistory(scriptHash);
        //
        // let txs: ElectrumTransactionShort[] = await this.client.blockchain_scripthash_getHistory(
        //   scriptHash
        // );
        //
        // return txs;
    }
    getTransaction(hash, verbose) {
        // todo: consider fetching block height
        return this.client.blockchain_transaction_get(hash, verbose);
    }
    getUnspentList(address) {
        const scriptHash = this.getScriptHash(address);
        return this.client.blockchain_scripthash_listunspent(scriptHash);
    }
    broadcastTransaction(rawtx) {
        return this.client.blockchain_transaction_broadcast(rawtx);
    }
    blockchainEstimateFee(number) {
        return this.client.blockchainEstimatefee(number);
    }
    getMempool(address) {
        const scriptHash = this.getScriptHash(address);
        return this.client.blockchain_scripthash_getMempool(scriptHash);
    }
}
exports.BtcvApiClient = BtcvApiClient;
