"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bufferReverse = exports.createPromiseResult = exports.makeRequest = void 0;
function makeRequest(method, params, id) {
    return JSON.stringify({
        jsonrpc: '2.0',
        method: method,
        params: params,
        id: id,
    });
}
exports.makeRequest = makeRequest;
function createPromiseResult(resolve, reject) {
    return (err, result) => {
        if (err)
            reject(err);
        else
            resolve(result);
    };
}
exports.createPromiseResult = createPromiseResult;
function bufferReverse(src) {
    const buffer = Buffer.allocUnsafe(src.length);
    for (let i = 0, j = src.length - 1; i <= j; ++i, --j) {
        buffer[i] = src[j];
        buffer[j] = src[i];
    }
    return buffer;
}
exports.bufferReverse = bufferReverse;
