/// <reference types="node" />
import { EventEmitter } from 'events';
import { MessageParser } from './util';
import { TCPSocketClient } from './socket_client_tcp';
import { WebSocketClient } from './socket_client_ws';
import { CallbackMessageQueue } from '../types';
import { ICloseEvent } from 'websocket';
export declare class SocketClient {
    private readonly host;
    private readonly port;
    private readonly protocol;
    private readonly options?;
    protected id: number;
    protected status: number;
    protected callback_message_queue: CallbackMessageQueue;
    protected subscribe: EventEmitter;
    protected messageParser: MessageParser;
    protected client: TCPSocketClient | WebSocketClient;
    constructor(host: string, port: number, protocol: string, options?: object | undefined);
    connect(): Promise<unknown>;
    close(): Promise<void>;
    response(msg: {
        id: number;
        error?: Error;
        result?: string;
    }): void;
    onMessage(body: string | ArrayBuffer | Buffer, n?: number): void;
    onConnect(): void;
    onClose(event?: ICloseEvent): void;
    onRecv(chunk: string): void;
    onEnd(error: Error): void;
    onError(error: Error): void;
}
