export declare type CallbackMessageQueue = ((err: any, result?: any) => void)[];
export declare type ElectrumTransactionIn = {
    txid: string;
    vout: number;
    scriptSig: {
        asm: string;
        hex: string;
    };
    txinwitness: string[];
    sequence: number;
};
export declare type ScriptPubKey = {
    asm: string;
    hex: string;
    reqSigs: number;
    type: string;
    addresses: string[];
};
export declare type ElectrumTransactionOut = {
    value: number;
    n: number;
    scriptPubKey: ScriptPubKey;
};
export declare type ElectrumTransaction = {
    txid: string;
    hash: string;
    version: number;
    size: number;
    vsize: number;
    weight: number;
    locktime: number;
    vin: ElectrumTransactionIn[];
    vout: ElectrumTransactionOut[];
    hex: string;
    blockhash: string;
    confirmations: string;
    time: string;
    blocktime: string;
    height?: number;
};
export declare type ElectrumTransactionShort = {
    tx_hash: string;
    height: number;
    tx_type: string;
    fee?: number;
};
export declare type ElectrumBalances = {
    confirmed: number;
    unconfirmed: number;
    alert_incoming: number;
    alert_outgoing: number;
};
export declare type ElectrumUTXO = {
    tx_hash: string;
    tx_pos: number;
    height: number;
    value: number;
    spend_tx_num: number;
};
export declare type CurrentBlock = {
    hex: string;
    height: number;
};
